%global debug_package %{nil}
%define soversion 0

Name:             qatlib
Version:          1911u
Release:          0.1%{?dist}
Summary:          Intel(R) QuickAssist user space library
License:          BSD
URL:              https://github.com/intel/%{name}
Source0:          QAT_UPSTREAM_19.11.0.L.0.0.0-00048.tar.gz
BuildRequires:    systemd
BuildRequires:    gcc
Requires:         glibc
Requires(post):   /sbin/ldconfig
Requires(postun): /sbin/ldconfig

%{?systemd_requires}

%description
Intel(R) QuickAssist Technology (Intel(R) QAT) provides a
software-enabled foundation for security, authentication, and
compression, and significantly increases the performance and
efficiency of standard platform solutions.

Intel(R) QAT improves performance across applications and platforms.
That includes symmetric encryption and authentication,
asymmetric encryption, digital signatures, RSA, DH, and ECC, and
lossless data compression.

This package provides user space libraries that allow access to
Intel(R) QuickAssist devices and expose the Intel(R) QuickAssist APIs.

%package       devel
Summary:       Headers and libraries to build applications that use qatlib
Requires:      %{name} = %{version}-%{release}

%description   devel
This package contains headers and libraries required to build applications
that use the Intel(R) QuickAssist APIs.

%prep
%autosetup -c

%build
%configure
%make_build

%install
mkdir -p %{buildroot}%{_sbindir}
mkdir -p %{buildroot}%{_libdir}
mkdir -p %{buildroot}%{_unitdir}
mkdir -p %{buildroot}%{_licensedir}/%{name}-%{version}
mkdir -p %{buildroot}%{_mandir}/man8

install -m 0644 LICENSE %{buildroot}%{_licensedir}/%{name}-%{version}
install -m 0644 LICENSE.OPENSSL %{buildroot}%{_licensedir}/%{name}-%{version}

install -s -m 0755 build/libqat_s.so %{buildroot}%{_libdir}/libqat.so.%{soversion}.%{version}
install -s -m 0755 build/libusdm_drv_s.so %{buildroot}%{_libdir}/libusdm.so.%{soversion}.%{version}
ln -s -f libqat.so.%{soversion}.%{version} %{buildroot}%{_libdir}/libqat.so
ln -s -f libusdm.so.%{soversion}.%{version} %{buildroot}%{_libdir}/libusdm.so

install -s -m 0755 build/qatmgr %{buildroot}%{_sbindir}
install -m 0755 quickassist/utilities/service/qat_init.sh %{buildroot}%{_sbindir}
install -m 0644 quickassist/utilities/service/qat.service %{buildroot}%{_unitdir}

install -m 0644 qat_init.sh.8 %{buildroot}%{_mandir}/man8
install -m 0644 qatmgr.8 %{buildroot}%{_mandir}/man8

mkdir -p %{buildroot}%{_includedir}/qat

install -m 0644 quickassist/include/cpa.h %{buildroot}%{_includedir}/qat
install -m 0644 quickassist/include/cpa_types.h %{buildroot}%{_includedir}/qat
install -m 0644 quickassist/include/lac/cpa_cy_common.h %{buildroot}%{_includedir}/qat
install -m 0644 quickassist/include/lac/cpa_cy_dh.h %{buildroot}%{_includedir}/qat
install -m 0644 quickassist/include/lac/cpa_cy_drbg.h %{buildroot}%{_includedir}/qat
install -m 0644 quickassist/include/lac/cpa_cy_dsa.h %{buildroot}%{_includedir}/qat
install -m 0644 quickassist/include/lac/cpa_cy_ecdh.h %{buildroot}%{_includedir}/qat
install -m 0644 quickassist/include/lac/cpa_cy_ecdsa.h %{buildroot}%{_includedir}/qat
install -m 0644 quickassist/include/lac/cpa_cy_ec.h %{buildroot}%{_includedir}/qat
install -m 0644 quickassist/include/lac/cpa_cy_im.h %{buildroot}%{_includedir}/qat
install -m 0644 quickassist/include/lac/cpa_cy_key.h %{buildroot}%{_includedir}/qat
install -m 0644 quickassist/include/lac/cpa_cy_ln.h %{buildroot}%{_includedir}/qat
install -m 0644 quickassist/include/lac/cpa_cy_nrbg.h %{buildroot}%{_includedir}/qat
install -m 0644 quickassist/include/lac/cpa_cy_prime.h %{buildroot}%{_includedir}/qat
install -m 0644 quickassist/include/lac/cpa_cy_rsa.h %{buildroot}%{_includedir}/qat
install -m 0644 quickassist/include/lac/cpa_cy_sym_dp.h %{buildroot}%{_includedir}/qat
install -m 0644 quickassist/include/lac/cpa_cy_sym.h %{buildroot}%{_includedir}/qat
install -m 0644 quickassist/include/dc/cpa_dc.h %{buildroot}%{_includedir}/qat
install -m 0644 quickassist/include/dc/cpa_dc_dp.h %{buildroot}%{_includedir}/qat
install -m 0644 quickassist/lookaside/access_layer/include/icp_sal_poll.h %{buildroot}%{_includedir}/qat
install -m 0644 quickassist/lookaside/access_layer/include/icp_sal_user.h %{buildroot}%{_includedir}/qat
install -m 0644 quickassist/lookaside/access_layer/include/icp_sal.h %{buildroot}%{_includedir}/qat
install -m 0644 quickassist/lookaside/access_layer/include/icp_sal_versions.h %{buildroot}%{_includedir}/qat
install -m 0644 quickassist/utilities/libusdm_drv/qae_mem.h %{buildroot}%{_includedir}/qat

%pre
/usr/sbin/groupadd qat 2> /dev/null || :

%post
%systemd_post qat.service
/sbin/ldconfig

%preun
%systemd_preun qat.service
/sbin/ldconfig

%postun
%systemd_postun_with_restart qat.service
/sbin/ldconfig

%files
%license %{_licensedir}/%{name}-%{version}/LICENSE*
%doc README
%{_libdir}/libqat.so.%{soversion}.%{version}
%{_libdir}/libusdm.so.%{soversion}.%{version}
%{_libdir}/libqat.so.%{soversion}
%{_libdir}/libusdm.so.%{soversion}
%{_sbindir}/qatmgr
%{_sbindir}/qat_init.sh
%{_unitdir}/qat.service
%{_mandir}/man8/qat_init.sh.8.gz
%{_mandir}/man8/qatmgr.8.gz

%files         devel
%{_libdir}/libqat.so
%{_libdir}/libusdm.so
%dir %{_includedir}/qat
%{_includedir}/qat/*

%changelog
* Thu Oct  3 2019 Giovanni Cabiddu <giovanni.cabiddu@intel.com> - 1911u-0.1
- Initial version of the package
